Page MenuHomeFreeBSD

[bhnd] Initial power/clock management support.
ClosedPublic

Authored by landonf on Aug 12 2016, 10:30 PM.

Details

Summary

Integrate initial PMU/PWRCTL driver support and supporting
bhnd(4) bus APIs:

  • Add bus-level support for per-core clock and resource power requests.
  • Add bhnd_pmu driver implementations for PMU and PWRCTL devices, derived from Broadcom's ISC-licensed HND code.

Depends on D7489
Depends on D7539

Test Plan
  • Test for successful device attach on:
    • N16, N53, BCM43225, BCM4312 (PMU devices)
    • WGT634U (non-PMU, non-PWRCTL)
  • Verify expected mem/cpu/bus frequency values under dev.bhnd_pmu sysctl

I could use a hand testing the PWRCTL code; I don't seem to have any
hardware that advertises PWRCTL support.

Diff Detail

Repository
rS FreeBSD src repository - subversion
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

landonf retitled this revision from to [bhnd] Initial power/clock management support..
landonf updated this object.
landonf edited the test plan for this revision. (Show Details)
landonf added reviewers: adrian, mizhka.

Drop unused static function declaration.

  • Resolve a minor conflict with the D7539 delta.

Does the code complain loudly if the hardware advertises PWRCTL support? That'd make it easier to evaluate.

Does the code complain loudly if the hardware advertises PWRCTL support? That'd make it easier to evaluate.

Not currently (it'll use a device description of 'ChipCommon Power Control' that differentiates it from the PMU driver, but that's about it).

Something like "WARNING: Using untested PWRCTL support" ?

adrian edited edge metadata.

yes, something exactly like that. :)

This revision is now accepted and ready to land.Aug 18 2016, 11:52 PM
landonf edited edge metadata.

Print a warning when using mostly-untested PWRCTL support.

This revision now requires review to proceed.Aug 19 2016, 7:15 PM
mizhka edited edge metadata.

Looks fine. Let's land it :)

This revision is now accepted and ready to land.Aug 22 2016, 9:53 AM
adrian edited edge metadata.
This revision was automatically updated to reflect the committed changes.